<?xml version="1.0" encoding="UTF-8"?>

<!-- Beans to add to the current Application context definition -->

<beans xmlns="http://www.springframework.org/schema/beans"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xmlns:p="http://www.springframework.org/schema/p"
       xmlns:context="http://www.springframework.org/schema/context"
       xmlns:jee="http://www.springframework.org/schema/jee"
       xmlns:tx="http://www.springframework.org/schema/tx"
       xmlns:aop="http://www.springframework.org/schema/aop"
       xmlns:util="http://www.springframework.org/schema/util"
       xsi:schemaLocation="http://www.springframework.org/schema/beans
            http://www.springframework.org/schema/beans/spring-beans-3.0.xsd
            http://www.springframework.org/schema/context
            http://www.springframework.org/schema/context/spring-context-3.0.xsd
            http://www.springframework.org/schema/jee
            http://www.springframework.org/schema/jee/spring-jee-3.0.xsd
            http://www.springframework.org/schema/tx
            http://www.springframework.org/schema/tx/spring-tx-3.0.xsd
            http://www.springframework.org/schema/aop
            http://www.springframework.org/schema/aop/spring-aop-3.0.xsd
            http://www.springframework.org/schema/util
            http://www.springframework.org/schema/util/spring-util-3.0.xsd">

    <context:component-scan base-package="org.openmrs.module.bahmnisms" />

   <!-- Wraps BahmnismsService methods in DB transactions and OpenMRS interceptors,
    which set audit info like dateCreated, changedBy, etc.-->
    <bean id="BahmnismsService"
            class="org.springframework.transaction.interceptor.TransactionProxyFactoryBean">
        <property name="transactionManager">
            <ref bean="transactionManager" />
        </property>
        <property name="target">
            <bean class="org.openmrs.module.bahmnisms.api.impl.BahmnismsServiceImpl">
                <property name="dao" ref="BahmnismsDao" />
            </bean>
        </property>
        <property name="preInterceptors">
            <ref bean="serviceInterceptors" />
        </property>
        <property name="transactionAttributeSource">
            <ref bean="transactionAttributeSource" />
        </property>
    </bean>

    <!-- Adds BahmnismsService to OpenMRS context so it can be accessed
    calling Context.getService(BahmnismsService.class) -->
    <bean parent="serviceContext">
        <property name="moduleService">
            <list>
                <value>org.openmrs.module.bahmnisms.api.BahmnismsService</value>
                <ref bean="BahmnismsService" />
            </list>
        </property>
    </bean>
</beans>
